 
%define rel 8

# this affects paths in sources.list: note 8.0 vs 9
%{!?rhrel:%define rhrel %(cut -d' ' -f5 /etc/redhat-release )}

%if "%{rhrel}" == "9"
%define distrel rh90
%else
%define distrel rh%(echo %{rhrel} | sed 's/\\.//')
%endif

# the python bindings only work with python >= 2.something
%define pythonver %(echo $(python2 -c "import sys; v=sys.version_info[:2]; print '%d.%d'%v" 2>/dev/null))
%define rpmver %(echo $(rpm -q --queryformat "%{VERSION}" rpm))

Summary: Debian's Advanced Packaging Tool with RPM support.
Name: apt
Version: 0.5.5cnc6
Release: 0.fdr.%{rel}.%{distrel}%{?_with_rpmlib:.rpmlib}
Epoch: 0
Group: System Environment/Base
License: GPL
Source0: http://moin.conectiva.com.br/files/AptRpm/attachments/%{name}-%{version}.tar.bz2
Source1: apt.conf
Source2: sources.list
Source3: vendors.list
Source4: apt_preferences
Source5: rpmpriorities.rh80
Source6: rpmpriorities.rh90
Source6: rpmpriorities.rh90.93
# Sources 50-99 are for Lua-scripts
Source50: gpg-checker.lua
Source51: gpg-import.lua
Source52: kernel-upgrade.lua
Source53: preserve-conf.lua
# 1XX for sources.list.d
Source100: macromedia.list
# 2xx for trusted gpg keys
# RH key
Source200: gpg-pubkey-db42a60e-37ea5438
# RH beta key
Source201: gpg-pubkey-897da07a-3c979a7f
# Fedora key
Source202: gpg-pubkey-8df56d05-3e828977
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

# others deps are automatically picked up by rpm
Requires: gnupg, bzip2

# FIXME: this needs more thought.. need to determine things like
# libelf-devel vs elfutils-devel from distro and use those instead of
# hardcoded etc.
%if "%{rpmver}" == "4.2.1"
BuildRequires: beecrypt-devel
BuildRequires: elfutils-devel
%endif
%if "%{rpmver}" == "4.2"
BuildRequires: elfutils-devel
%endif
%if "%{rpmver}" == "4.1.1"
BuildRequires: libelf-devel
%endif
%if "%{rpmver}" == "4.1"
BuildRequires: libelf-devel
%endif

%if "%{rhrel}" != "7.3"
BuildRequires: gettext >= 0:0.11.4
%define python python
%else
%define python python2
%endif

BuildRequires: %{python}-devel >= 0:%{pythonver}
BuildRequires: rpm-devel, zlib-devel, bzip2-devel, libstdc++-devel
BuildRequires: docbook-utils, perl, bison, readline-devel, ncurses-devel

# Fix rpmpriorities file for rh73
Patch0: apt-0.5.4cnc7-rpmpriorities.patch
# Fix some issues in python binding build
Patch1: apt-0.5.5cnc5-pymake.patch
# Only look at files ending in .list in sources.list.d directory
Patch2: apt-0.5.5cnc4.1-sourcelist.patch
# Fix segfault in rpm-dir with dangling symlinks 
Patch3: apt-0.5.5-rpmdir-symlink.patch
# Speed up initializing by not checking header signatures & digests at startup
Patch4: apt-0.5.5cnc5-nodigest.patch
# Fix installing older allowduplicated packages
Patch5: apt-0.5.5cnc5-oldpkg.patch
# Experimental rpm-src-dir support (works only partially)
Patch6: apt-0.5.5cnc5-src-dir-00.patch
# Fix building with rpm >= 4.2.1
Patch7: apt-0.5.5cnc6-fclose.patch
# Support pkg=version for virtual packages on the command line
Patch8: apt-0.5.5cnc6-virtver.patch
# Support build dependencies on virtual provides (patch from Debian upstream)
Patch9: apt-0.5.5cnc6-builddepvirtual.patch

# Experimental patch to remove the call to external rpm binary 
# Enable with "--with rpmlib" 
Patch20: apt-0.5.5cnc6-rpmlib-2.patch

%description
A port of Debian's apt tools for RPM based distributions.
It provides the apt-get utility that provides a simpler, safer way to 
install and upgrade packages. APT features complete installation ordering, 
multiple source capability and several other unique features.

%package devel
Summary: Development files and documentation for APT's libapt-pkg.
Group: Development/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: rpm-devel
%description devel
This package contains the header files and static libraries for developing
with APT's libapt-pkg package manipulation library, modified for RPM.

%package python
Summary: Python bindings for libapt-pkg
Group: Development/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}, %{python} => 0:%{pythonver}
%description python
The apt-python package contains a module which allows python programs
to access the APT library interface.

%prep
%setup -q
%patch0 -p1 -b .rpmpriorities
%patch1 -p1 -b .pymake
%patch2 -p1 -b .sourcelist
%patch3 -p1 -b .rpmdir
%patch4 -p1 -b .nodigest
%patch5 -p1 -b .oldpkg
%patch6 -p1 -b .srcdir
%patch7 -p1 -b .fclose
%patch8 -p1 -b .virtver
%patch9 -p1 -b .builddep

%if %{?_with_rpmlib:1}%{!?_with_rpmlib:0}
%patch20 -p1 -b .rpmlib
%endif

# fix docs to reference correct paths
perl -pi -e \
  's|\bconfigure-index\.gz\b|configure-index| ;
   s|/usr/share/doc/apt/|%{_docdir}/%{name}-%{version}/|' \
  doc/apt.ent doc/fr/apt.ent.fr

# use /usr/bin/python2
perl -pi -e 's|python -c|%{python} -c|' python/Makefile

%build
# disabling build dep tracking ought to make rpm-building a bit faster
%configure \
	--disable-dependency-tracking \
%if "%{rhrel}" == "7.3"
	--disable-scripts \
	--with-included-gettext \
%endif


make %{?_smp_mflags} NOISY=1

touch python/apt.py python/apt_wrap.cxx
make -C python %{?_smp_mflags}
%{python} -c "import py_compile; py_compile.compile('python/apt.py')"

%install
rm -rf %{buildroot}

%makeinstall includedir=%{buildroot}%{_includedir}/apt-pkg
%find_lang %{name}

# The state files
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/archives/partial
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/genpkglist
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/gensrclist
mkdir -p %{buildroot}%{_localstatedir}/state/apt/lists/partial


# The config files
mkdir -p %{buildroot}%{_sysconfdir}/apt
mkdir -p %{buildroot}%{_sysconfdir}/apt/scripts
mkdir -p %{buildroot}%{_sysconfdir}/apt/apt.conf.d
mkdir -p %{buildroot}%{_sysconfdir}/apt/sources.list.d
mkdir -p %{buildroot}%{_sysconfdir}/apt/vendors.list.d
install -p -m 644 %{SOURCE1} %{SOURCE2} %{SOURCE3} %{buildroot}%{_sysconfdir}/apt/
install -p -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/apt/preferences
# FIXME: generate useful rpmpriorities for 7x too...
%if "%{rhrel}" == "7.3"
install -p -m 644 rpmpriorities %{buildroot}%{_sysconfdir}/apt/
%else
install -p -m 644 $RPM_SOURCE_DIR/rpmpriorities.%{distrel} %{buildroot}%{_sysconfdir}/apt/rpmpriorities
%endif

# install sources.list.d entries
for srclist in %{SOURCE100}; do
	install -p -m 644 $srclist %{buildroot}%{_sysconfdir}/apt/sources.list.d/
done

# Fixup source list entries
%if "%{rhrel}" == "7.3"
# Handle macromedia repo exception
perl -pi -e "s/RHREL/7.x/g" \
	%{buildroot}%{_sysconfdir}/apt/sources.list.d/macromedia.list
# fedora doesn't do 7.3 (yet).
perl -pi -e "s/^rpm/#rpm/g" %{buildroot}%{_sysconfdir}/apt/sources.list
%endif
 
perl -pi -e "s/RHREL/%{rhrel}/g" \
	%{buildroot}%{_sysconfdir}/apt/sources.list \
	%{buildroot}%{_sysconfdir}/apt/sources.list.d/*.list


# GPG keys
mkdir -p %{buildroot}%{_sysconfdir}/apt/gpg/
for gpgkey in %{SOURCE200} %{SOURCE201} %{SOURCE202}; do
	install -p -m 644  $gpgkey %{buildroot}%{_sysconfdir}/apt/gpg/
done

# Lua scripts
mkdir -p %{buildroot}%{_libdir}/apt/scripts
for script in %{SOURCE50} %{SOURCE51} %{SOURCE52} %{SOURCE53}; do
	install -p -m 755 $script %{buildroot}%{_libdir}/apt/scripts/
done


# The python bindings
mkdir -p %{buildroot}%{_libdir}/python%{pythonver}/site-packages/
install -p -m 755 python/apt.py* python/_apt.so %{buildroot}%{_libdir}/python%{pythonver}/site-packages/

# nuke .la files
rm -f %{buildroot}%{_libdir}/*.la

%post
/sbin/ldconfig
# Fix apt config for Lua-based gpg checking
CONF=/etc/apt/apt.conf
perl -pi -e 's:.*/usr/bin/apt-sigchecker.*:  GPG-Check "true";:g' $CONF
if ! grep -q "gpg-checker.lua" $CONF; then
	echo 'Scripts::Init:: "gpg-import.lua";' >> $CONF
	echo 'Scripts::RPM::Pre:: "gpg-checker.lua";' >> $CONF
fi

%postun -p /sbin/ldconfig

%clean
rm -rf %{buildroot}


%files -f %{name}.lang
%defattr(-, root, root)
%doc AUTHORS* COPYING* ABOUT* TODO doc/examples/ contrib/
%dir %{_sysconfdir}/apt
%dir %{_sysconfdir}/apt/sources.list.d
%dir %{_sysconfdir}/apt/vendors.list.d
%dir %{_sysconfdir}/apt/apt.conf.d
%dir %{_sysconfdir}/apt/gpg
%{_sysconfdir}/apt/gpg/gpg-pubkey*
%config(noreplace) %{_sysconfdir}/apt/apt.conf 
%config(noreplace) %{_sysconfdir}/apt/preferences
%config(noreplace) %{_sysconfdir}/apt/sources.list
%config(noreplace) %{_sysconfdir}/apt/sources.list.d/*.list
%config(noreplace) %{_sysconfdir}/apt/vendors.list
%config(noreplace) %{_sysconfdir}/apt/rpmpriorities
%{_bindir}/apt-cache
%{_bindir}/apt-cdrom
%{_bindir}/apt-config
%{_bindir}/apt-shell
%{_bindir}/apt-get
%{_bindir}/genpkglist
%{_bindir}/gensrclist
%{_bindir}/genbasedir
%{_libdir}/*.so.*
%{_libdir}/apt
%{_mandir}/man?/*
%{_localstatedir}/cache/apt
%{_localstatedir}/state/apt


%files devel
%defattr(-, root, root)
%{_includedir}/apt-pkg/*
%{_libdir}/*.so
%{_libdir}/*.a

%files python
%defattr(-, root, root)
%{_libdir}/python%{pythonver}/site-packages/*

%changelog
* Wed Sep 03 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.8
- add patch 9 to support build dependencies on virtual packages (#667)
- config(noreplace) for /etc/apt/rpmpriorities (#629)
- better reporting of signature problems in gpg-checker.lua

* Fri Aug 29 2003 Panu Matilainen <pmatilai@welho.com>
- add contrib stuff as docs
- add bzip2 dependency (#629)

* Tue Aug 19 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.7
- use apterror() instead of exit in gpg-checker.lua to allow smoother
  operation with synaptic
- support pkg=ver syntax for virtual packages (patch 8)
- strict version-release dependency in apt-python
- when built with --with rpmlib add .rpmlib to release string

* Tue Aug 19 2003 Panu Matilainen <pmatilai@welho.com>
- fix #558, #611

* Mon Jul 21 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.6
- fix build on RH 9.0.93
- detect rpm-related buildreqs from rpm version, not distro version
- some spec rearrangements
- comment the patches

* Sat Jul 19 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.5
- use -p option with install
- add beecrypt-devel buildreq for rpm-4.2.1

* Mon Jul 14 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.4
- fix typos in gpg-checker script

* Mon Jul 07 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.3
- fix apt.conf for gpg checking with lua in post

* Fri Jun 13 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.2
- add patch to allow build against rpm-4.2.1
- add --with rpmlib build option

* Thu Jun 12 2003 Panu Matilainen <pmatilai@welho.com>
- EXPERIMENTAL patch to make apt use only rpmlib

* Tue Jun 10 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc6-0.fdr.1
- update to 0.5.5cnc6
- drop patches merged upstream

* Tue Jun 10 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc5-0.fdr.9
- patch from upstream to fix a security problem where lua-scripts can get 
  accidentally executed from cwd

* Mon Jun 09 2003 Panu Matilainen <pmatilai@welho.com>
- apt doesn't like build deps on versioned virtual provides -> only RH7.3
  package buildrequires python2-devel, newer ones have python-devel 

* Thu Jun 05 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc5-0.fdr.8
- fix the proxy template format in apt.conf
- fix hang when reading package lists on duplicate packages

* Thu May 22 2003 Panu Matilainen <pmatilai@welho.com>
- automatically handle installing older allowdup pkgs with new rpms

* Mon May 19 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc5-0.fdr.7
- fix thinkos/typos in gpg-checker + config

* Mon May 19 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc5-0.fdr.6
- import some of the changes in #149:
  - detect distrel, rhrel automatically
  - rename GPG keys to their rpmdb names for easier checking
  - use install instead of cp
- use Lua GPG-sigchecker, split importing them to another script
- include kernel-upgrade and preserve-conf Lua-scripts
- move lua scripts from /etc/apt to /usr/lib/apt (upstream change in svn tree)
- list explicitly binaries so we know if something fails
- fix #259
- add missing ncurses-devel buildreq (for apt-shell)

* Sat May 03 2003 Panu Matilainen <pmatilai@welho.com> 
- add missing libelf-devel buildreq for RH8.0 (#254)
- add missing readline-devel buildreq (for apt-shell)

* Thu Apr 24 2003 Panu Matilainen <pmatilai@welho.com> 
- add /etc/apt/scripts directory (for Lua scripts)

* Tue Apr 22 2003 Warren Togami <warren@togami.com> 0.5.5cnc5-0.fdr.5
- Bug #172 comment #18 apt.conf proxy syntax

* Tue Apr 22 2003 Warren Togami <warren@togami.com> 0.5.5cnc5-0.fdr.4
- elfutils-devel exists only in RH9

* Tue Apr 22 2003 Warren Togami <warren@togami.com> 0.5.5cnc5-0.fdr.3
- Patch epoch comparison behavior, rpmvercmp.warren.patch
  http://www.fedora.us/pipermail/fedora-devel/2003-April/001043.html

* Thu Apr 17 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc5-0.fdr.2
- add missing buildreq elfutils-devel
- rpmpriorities for non %{distrel} wasn't getting included in src.rpm

* Wed Apr 16 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc5-0.fdr.1
- patch to speed up apt startup and genbasedir
- drop "counting sheep" patch, not needed anymore
- include current mirrors in sources.list 
- autodetect RH version

* Tue Apr 15 2003 Panu Matilainen <pmatilai@welho.com>
- update to official 0.5.5cnc5
- use g++ not gcc to build python bindings
- more selected merging from #149
- include Fedora GPG fingerprint in vendors.list "just in case"

* Mon Apr 14 2003 Panu Matilainen <pmatilai@welho.com>
- update to newer snapshot (new make system, lua interface ...)
- rearrange spec accordingly, use %find_lang etc
- drop unneeded patches (filedeps..)
- only look at .list files in sources.list.d
- merge selected patches by Rex Dieter / #149
- include French mirror in sources.list (commented out)

* Mon Apr 07 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc4.1-0.fdr.7
- optional patch to ignore signals while rpmdb lock is held to avoid stale locks
- add epoch to requires =, >= too

* Thu Apr 03 2003 Panu Matilainen <pmatilai@welho.com>
- fix segfault if rpm-dir index is a broken symlink 
- rpmpriorities generated from comps.xml
- dont tag the various keys as %dir :-/

* Mon Mar 31 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc4.1-0.fdr.5
- add Ville's suggested fixes from #12 (doc paths, stricter regexps in apt.conf)

* Mon Mar 31 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc4.1-0.fdr.4
- use 7.x instead of 7.3 in macromedia repository
- add Epoch 0
- add patch from svn for massive file dependency breakage on certain situations
- add patch4 to tell something is happening when apt is counting packages
  on startup

* Fri Mar 27 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc4.1-0.fdr.3
- dont bother building translations since we're not installing them anyway
  which fixes build on RH7.x (7.3 at least)

* Thu Mar 27 2003 Panu Matilainen <pmatilai@welho.com> 0.5.5cnc4.1.0.fdr.2
- add macromedia.list
- import GPG keys on first run, not from %post
- require gnupg (needed with authenticated repositories)

* Tue Mar 25 2003 Panu Matilainen <pmatilai@welho.com>
- import GPG keys from %post
- drop the -kernel$ entries from apt.conf
- add Default-Release = stable to apt.conf

* Sat Mar 23 2003 Panu Matilainen <pmatilai@welho.com>
- Initial Fedora packaging (reset changelog)
